from darts.reservoirs.mesh.geometry.shapes import *


class FluidFlower(Shape):
    def __init__(self, lc: list):
        self.lc = lc

        """Define points, curves, surfaces, volumes"""
        self.points = [Point(1, [0.0, 0.0, 0.0]),
                       Point(2, [0.31133, 0.0, 0.0]),
                       Point(3, [0.32596, 0.0, 0.06881]),
                       Point(4, [0.22681, 0.0, 0.0939]),
                       Point(5, [0.12927, 0.0, 0.10987]),
                       Point(6, [0.0, 0.0, 0.11716]),
                       Point(7, [0.34547, 0.0, 0.1342]),
                       Point(8, [0.3758, 0.0, 0.27496]),
                       Point(9, [0.38046, 0.0, 0.29662]),
                       Point(10, [0.12644, 0.0, 0.33318]),
                       Point(11, [0.0, 0.0, 0.31382]),
                       Point(12, [0.40825, 0.0, 0.421]),
                       Point(13, [0.42299, 0.0, 0.48694]),
                       Point(14, [0.39195, 0.0, 0.47189]),
                       Point(15, [0.32184, 0.0, 0.46866]),
                       Point(16, [0.22529, 0.0, 0.48587]),
                       Point(17, [0.12529, 0.0, 0.49232]),
                       Point(18, [0.0, 0.0, 0.46436]),
                       Point(19, [0.47343, 0.0, 0.6167]),
                       Point(20, [0.42414, 0.0, 0.6106]),
                       Point(21, [0.32184, 0.0, 0.6278]),
                       Point(22, [0.22644, 0.0, 0.6278]),
                       Point(23, [0.0, 0.0, 0.61006]),
                       Point(24, [0.5047, 0.0, 0.70425]),
                       Point(25, [0.42414, 0.0, 0.69985]),
                       Point(26, [0.22701, 0.0, 0.72673]),
                       Point(27, [0.12586, 0.0, 0.72888]),
                       Point(28, [0.0, 0.0, 0.70361]),
                       Point(29, [0.52069, 0.0, 0.74501]),
                       Point(30, [0.5069, 0.0, 0.75899]),
                       Point(31, [0.12562, 0.0, 0.75653]),
                       Point(32, [0.0, 0.0, 0.73802]),
                       Point(33, [0.36091, 0.0, 0.0]),
                       Point(34, [0.39295, 0.0, 0.14588]),
                       Point(35, [0.43081, 0.0, 0.31059]),
                       Point(36, [0.44625, 0.0, 0.36382]),
                       Point(37, [0.41293, 0.0, 0.36534]),
                       Point(38, [0.41618, 0.0, 0.3775]),
                       Point(39, [0.45275, 0.0, 0.39575]),
                       Point(40, [0.4682, 0.0, 0.44213]),
                       Point(41, [0.42011, 0.0, 0.42888]),
                       Point(42, [0.42529, 0.0, 0.45899]),
                       Point(43, [0.43966, 0.0, 0.47028]),
                       Point(44, [0.45287, 0.0, 0.50361]),
                       Point(45, [0.4477, 0.0, 0.52135]),
                       Point(46, [0.4592, 0.0, 0.55361]),
                       Point(47, [0.47586, 0.0, 0.56597]),
                       Point(48, [0.49655, 0.0, 0.61544]),
                       Point(49, [0.49023, 0.0, 0.62995]),
                       Point(50, [0.49655, 0.0, 0.64501]),
                       Point(51, [0.52126, 0.0, 0.67404]),
                       Point(52, [0.5362, 0.0, 0.72274]),
                       Point(53, [0.54138, 0.0, 0.73963]),
                       Point(54, [0.57529, 0.0, 0.76329]),
                       Point(55, [0.43731, 0.0, 0.44897]),
                       Point(56, [0.46982, 0.0, 0.47026]),
                       Point(57, [0.46332, 0.0, 0.47939]),
                       Point(58, [0.47551, 0.0, 0.51664]),
                       Point(59, [0.46657, 0.0, 0.54554]),
                       Point(60, [0.49014, 0.0, 0.54706]),
                       Point(61, [0.50558, 0.0, 0.58964]),
                       Point(62, [2.78458, 0.0, 0.0]),
                       Point(63, [2.43333, 0.0, 0.1106]),
                       Point(64, [2.13218, 0.0, 0.13963]),
                       Point(65, [1.52759, 0.0, 0.13748]),
                       Point(66, [0.82184, 0.0, 0.07834]),
                       Point(67, [0.62989, 0.0, 0.08157]),
                       Point(68, [2.85954, 0.0, 0.0]),
                       Point(69, [2.85954, 0.0, 0.38663]),
                       Point(70, [2.73338, 0.0, 0.40792]),
                       Point(71, [2.53506, 0.0, 0.45658]),
                       Point(72, [2.43225, 0.0, 0.47064]),
                       Point(73, [2.28676, 0.0, 0.50486]),
                       Point(74, [2.03033, 0.0, 0.53109]),
                       Point(75, [1.7288, 0.0, 0.52957]),
                       Point(76, [1.22784, 0.0, 0.49471]),
                       Point(77, [1.12735, 0.0, 0.49535]),
                       Point(78, [0.72219, 0.0, 0.43149]),
                       Point(79, [0.62425, 0.0, 0.42769]),
                       Point(80, [0.52184, 0.0, 0.44365]),
                       Point(81, [2.85954, 0.0, 0.52957]),
                       Point(82, [2.73338, 0.0, 0.53793]),
                       Point(83, [2.23027, 0.0, 0.63221]),
                       Point(84, [1.92995, 0.0, 0.65279]),
                       Point(85, [1.2406, 0.0, 0.6459]),
                       Point(86, [1.22001, 0.0, 0.63906]),
                       Point(87, [1.0924, 0.0, 0.64134]),
                       Point(88, [0.825, 0.0, 0.59876]),
                       Point(89, [0.62506, 0.0, 0.58279]),
                       Point(90, [2.85954, 0.0, 0.6421]),
                       Point(91, [2.43218, 0.0, 0.70683]),
                       Point(92, [2.03276, 0.0, 0.73425]),
                       Point(93, [1.52529, 0.0, 0.70361]),
                       Point(94, [1.41149, 0.0, 0.71705]),
                       Point(95, [1.40287, 0.0, 0.6864]),
                       Point(96, [1.38103, 0.0, 0.6864]),
                       Point(97, [1.37529, 0.0, 0.67458]),
                       Point(98, [1.36495, 0.0, 0.6739]),
                       Point(99, [1.16897, 0.0, 0.66114]),
                       Point(100, [1.12069, 0.0, 0.74554]),
                       Point(101, [1.11667, 0.0, 0.76114]),
                       Point(102, [1.10229, 0.0, 0.76119]),
                       Point(103, [1.06924, 0.0, 0.85334]),
                       Point(104, [0.71934, 0.0, 0.8778]),
                       Point(105, [0.0, 0.0, 0.84877]),
                       Point(106, [1.03694, 0.0, 0.94338]),
                       Point(107, [0.72097, 0.0, 0.96828]),
                       Point(108, [0.0, 0.0, 0.93479]),
                       Point(109, [1.00938, 0.0, 1.0202]),
                       Point(110, [0.92578, 0.0, 1.03063]),
                       Point(111, [0.0, 0.0, 1.02296]),
                       Point(112, [0.98621, 0.0, 1.08479]),
                       Point(113, [0.98621, 0.0, 1.09877]),
                       Point(114, [0.97816, 0.0, 1.08802]),
                       Point(115, [0.76092, 0.0, 1.09339]),
                       Point(116, [0.22184, 0.0, 1.07081]),
                       Point(117, [0.0, 0.0, 1.0735]),
                       Point(118, [1.40809, 0.0, 0.78642]),
                       Point(119, [1.22691, 0.0, 0.77135]),
                       Point(120, [1.10967, 0.0, 0.78724]),
                       Point(121, [1.44173, 0.0, 0.87416]),
                       Point(122, [1.23017, 0.0, 0.86183]),
                       Point(123, [1.06203, 0.0, 0.90244]),
                       Point(124, [1.07184, 0.0, 0.86597]),
                       Point(125, [1.08966, 0.0, 0.84716]),
                       Point(126, [1.46178, 0.0, 0.92646]),
                       Point(127, [1.40891, 0.0, 0.91302]),
                       Point(128, [1.21408, 0.0, 0.90173]),
                       Point(129, [1.21609, 0.0, 0.9114]),
                       Point(130, [1.425, 0.0, 0.92538]),
                       Point(131, [1.46724, 0.0, 0.94366]),
                       Point(132, [1.47777, 0.0, 0.97543]),
                       Point(133, [1.42523, 0.0, 0.96334]),
                       Point(134, [1.2257, 0.0, 0.95688]),
                       Point(135, [1.12532, 0.0, 0.9717]),
                       Point(136, [1.02323, 0.0, 1.00361]),
                       Point(137, [1.02931, 0.0, 0.9864]),
                       Point(138, [1.05057, 0.0, 0.94501]),
                       Point(139, [1.48764, 0.0, 1.00522]),
                       Point(140, [1.43736, 0.0, 0.99635]),
                       Point(141, [1.32615, 0.0, 0.99393]),
                       Point(142, [1.32701, 0.0, 0.99904]),
                       Point(143, [1.42874, 0.0, 1.00495]),
                       Point(144, [1.49224, 0.0, 1.01732]),
                       Point(145, [1.51149, 0.0, 1.06544]),
                       Point(146, [1.4977, 0.0, 1.05468]),
                       Point(147, [1.42529, 0.0, 1.04286]),
                       Point(148, [1.22644, 0.0, 1.03963]),
                       Point(149, [1.12299, 0.0, 1.05253]),
                       Point(150, [1.02414, 0.0, 1.07511]),
                       Point(151, [0.99885, 0.0, 1.09339]),
                       Point(152, [1.00402, 0.0, 1.05791]),
                       Point(153, [1.4477, 0.0, 0.82583]),
                       Point(154, [1.48307, 0.0, 0.9321]),
                       Point(155, [1.51096, 0.0, 1.0159]),
                       Point(156, [1.52828, 0.0, 1.06774]),
                       Point(157, [2.85954, 0.0, 0.67783]),
                       Point(158, [2.52775, 0.0, 0.74778]),
                       Point(159, [2.27942, 0.0, 0.77643]),
                       Point(160, [2.28423, 0.0, 0.78628]),
                       Point(161, [2.531, 0.0, 0.76147]),
                       Point(162, [2.85954, 0.0, 0.70673]),
                       Point(163, [2.85954, 0.0, 0.75007]),
                       Point(164, [2.42696, 0.0, 0.84891]),
                       Point(165, [2.03277, 0.0, 0.86564]),
                       Point(166, [2.85954, 0.0, 0.85043]),
                       Point(167, [2.63503, 0.0, 0.90593]),
                       Point(168, [2.23353, 0.0, 0.95155]),
                       Point(169, [1.83202, 0.0, 0.95383]),
                       Point(170, [2.85954, 0.0, 0.94927]),
                       Point(171, [2.53262, 0.0, 1.00706]),
                       Point(172, [2.07504, 0.0, 1.04735]),
                       Point(173, [2.85954, 0.0, 1.0177]),
                       Point(174, [2.32989, 0.0, 1.08909]),
                       Point(175, [2.02759, 0.0, 1.09769]),
                       Point(176, [1.62473, 0.0, 1.08097]),
                       Point(177, [0.97241, 0.0, 1.14931]),
                       Point(178, [0.98851, 0.0, 1.15468]),
                       Point(179, [1.0023, 0.0, 1.10737]),
                       Point(180, [2.85954, 0.0, 1.33324]),
                       Point(181, [2.68966, 0.0, 1.32673]),
                       Point(182, [2.53448, 0.0, 1.33425]),
                       Point(183, [2.08621, 0.0, 1.31162]),
                       Point(184, [1.62644, 0.0, 1.3106]),
                       Point(185, [1.52759, 0.0, 1.30415]),
                       Point(186, [1.42644, 0.0, 1.28587]),
                       Point(187, [1.22759, 0.0, 1.27726]),
                       Point(188, [1.12644, 0.0, 1.28479]),
                       Point(189, [1.02184, 0.0, 1.31275]),
                       Point(190, [0.97184, 0.0, 1.30791]),
                       Point(191, [0.92414, 0.0, 1.29232]),
                       Point(192, [0.51954, 0.0, 1.28802]),
                       Point(193, [0.30759, 0.0, 1.3008]),
                       Point(194, [0.07701, 0.0, 1.30173]),
                       Point(195, [0.0, 0.0, 1.30683]),
                       Point(196, [2.85954, 0.0, 1.36329]),
                       Point(197, [0.0, 0.0, 1.36329]),
                       ]

        self.curves = [Curve(1, curve_type='line', points=[196, 197]),
                       ]

        self.surfaces = [Surface(1, points=[1, 2, 3, 4, 5, 6, 1]),
                         Surface(2, points=[6, 5, 4, 3, 7, 8, 9, 10, 11, 6]),
                         Surface(3, points=[11, 10, 9, 12, 13, 14, 15, 16, 17, 18, 11]),
                         Surface(4, points=[18, 17, 16, 15, 14, 13, 19, 20, 21, 22, 23, 18]),
                         Surface(5, points=[23, 22, 21, 20, 19, 24, 25, 26, 27, 28, 23]),
                         Surface(6, points=[28, 27, 26, 25, 24, 29, 30, 31, 32, 28]),
                         Surface(7, points=[2, 33, 34, 35, 8, 7, 3, 2]),
                         Surface(8, points=[8, 35, 36, 37, 38, 39, 40, 41, 12, 9, 8]),
                         Surface(9, points=[12, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 30, 29, 24, 19, 13, 12]),
                         Surface(10, points=[41, 40, 55, 56, 57, 58, 59, 60, 61, 51, 50, 49, 48, 47, 46, 45, 44, 43, 42, 41]),
                         Surface(11, points=[33, 62, 63, 64, 65, 66, 67, 34, 33]),
                         Surface(12, points=[62, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 40, 39, 38, 37, 36, 35, 34, 67, 66, 65, 64, 63, 62]),
                         Surface(13, points=[40, 80, 79, 78, 77, 76, 75, 74, 73, 72, 71, 70, 69, 81, 82, 83, 84, 85, 86, 87, 88, 89, 61, 60, 59, 58, 57, 56, 55, 40]),
                         Surface(14, points=[61, 89, 88, 87, 86, 85, 84, 83, 82, 81, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 52, 51, 61]),
                         Surface(15, points=[52, 100, 101, 102, 54, 53, 52]),
                         Surface(16, points=[32, 31, 30, 54, 102, 103, 104, 105, 32]),
                         Surface(17, points=[105, 104, 103, 106, 107, 108, 105]),
                         Surface(18, points=[108, 107, 106, 109, 110, 111, 108]),
                         Surface(19, points=[111, 110, 109, 112, 113, 114, 115, 116, 117, 111]),
                         Surface(20, points=[99, 98, 118, 119, 120, 101, 100, 99]),
                         Surface(21, points=[120, 119, 118, 121, 122, 123, 124, 125, 120]),
                         Surface(22, points=[123, 122, 121, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 123]),
                         Surface(23, points=[136, 135, 134, 133, 132, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 136]),
                         Surface(24, points=[98, 97, 96, 95, 94, 153, 154, 155, 156, 145, 144, 143, 142, 141, 140, 139, 132, 131, 130, 129, 128, 127, 126, 121, 118, 98]),
                         Surface(25, points=[94, 93, 92, 91, 90, 157, 158, 159, 160, 161, 162, 163, 164, 165, 153, 94]),
                         Surface(26, points=[157, 158, 159, 160, 161, 162, 157]),
                         Surface(27, points=[153, 165, 164, 163, 166, 167, 168, 169, 154, 153]),
                         Surface(28, points=[154, 169, 168, 167, 166, 170, 171, 172, 155, 154]),
                         Surface(29, points=[155, 172, 171, 170, 173, 174, 175, 176, 156, 155]),
                         Surface(30, points=[117, 116, 115, 114, 113, 177, 178, 179, 151, 150, 149, 148, 147, 146, 145, 156, 176, 175, 174, 173, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 117]),
                         Surface(31, points=[195, 194, 193, 192, 191, 190, 189, 188, 187, 186, 185, 184, 183, 182, 181, 180, 196, 197, 195])
                         ]

        self.connect_points()

        self.volumes = []

        """Define Physical Points, Curves, Surfaces, Volumes"""
        self.physical_points = {}

        self.physical_curves = {#'top': [1],
                                }

        self.physical_surfaces = {}

        self.physical_volumes = {}

    def plot_shape_2D(self):
        """
        Function to plot FluidFlower with extra
        """
        import matplotlib.pyplot as plt
        super().plot_shape_2D()

        colours = ['blue', 'mediumseagreen', 'lightskyblue', 'orchid', 'dodgerblue', 'darkcyan']

        # Plot wells, sensors and boxes
        wells = [[0.925, 0.0, 0.32942],
                 [1.72806, 0.0, 0.72757]]
        sensors = [[1.53, 0., 0.53],
                   [1.73, 0., 1.13]]
        boxes = [[[1.13, 2.83], [0., 0.], [0.03, 0.63]],
                 [[0.03, 1.13], [0., 0.], [0.63, 1.23]],
                 [[1.13, 2.63], [0., 0.], [0.13, 0.43]]]

        ii = 0
        for i, well in enumerate(wells):
            plt.scatter(well[0], well[2], c=colours[ii+i], label='I-' + str(i+1))

        ii = 2
        for i, sensor in enumerate(sensors):
            plt.scatter(sensor[0], sensor[2], c=colours[ii+i], label='S-' + str(i+1))

        box_label = ["Box A", "Box B", "Box C"]
        ii = 4
        for i, box in enumerate(boxes):
            x = [box[0][0], box[0][0], box[0][1], box[0][1], box[0][0]]
            z = [box[2][0], box[2][1], box[2][1], box[2][0], box[2][0]]
            plt.plot(x, z, c=colours[i], linestyle='--', alpha=0.7, label=box_label[i])

        plt.legend(bbox_to_anchor=(1.02, 1), loc="upper left")

        plt.tight_layout()
        plt.savefig('fluidflower_base.pdf', format='pdf', dpi=1000)
        plt.close()

        return
